import java.lang.*;
import java.net.*;
import java.util.*;
import java.io.*;
import GIS_Database;
import UDPconn;
import Tablica;
import java.awt.*;



class DB_Daemon extends Thread   
{
   static final int PACKET_LENGHT=50;
   static byte BUFFER[] = new byte[PACKET_LENGHT];   
   String Thost = "sandman";
   int Tport_read = 7500;
   int Tport_write = 6000;
   Button bt;
   Vector vect_data;
   Vector vect_stamp;

  
   GIS_Database GIS_db = new GIS_Database();     
   UDPconn serv_conn = new UDPconn();

   public DB_Daemon(String str, Button b)
   {
     super(str);
     bt = b;
     System.out.println("New thread "+getName()+" created"); 
   }

   public void run() 
   { 
     if (!GIS_db.IsConnected()) GIS_db.open();
 
     System.out.println("thread "+getName()+" run"); 
 
     if (getName().equals("read")) read_data();
     if (getName().equals("write")) write_data(); 
   }

   public void destroy()
   {
     
     //stop();
    
     //serv_conn.close_socket();

     if (GIS_db.IsConnected()) GIS_db.close();    
     System.out.println("thread "+getName()+" destroyed");
     stop();
   }
   
 
   public void read_data()     //reading client
   {
     Tablica BUFFER;
     vect_data = new Vector();
     vect_stamp = new Vector();
     Long stamp;
     
     serv_conn.open_read(Tport_read); 
     System.out.println("Reading client started on port :" + Tport_read);
     
     while (1==1)
     {

       BUFFER = new Tablica();
       BUFFER.tab = new byte[PACKET_LENGHT];
       
       serv_conn.read(BUFFER.tab, PACKET_LENGHT);

       stamp = new Long(System.currentTimeMillis());

       vect_data.addElement(BUFFER);
       vect_stamp.addElement(stamp);
       
     } 
       
     
   }
     
   public void toDB() {

       bt.disable();
       System.out.println("Recording in progress");
       GIS_db.insert(vect_data, vect_stamp);
       System.out.println("Recording is over");
       bt.enable();
   }
  
  
   public void write_data ()      //writing client
   {
     int vol;
     Long ob_time;
     long time,p;
     Tablica BUFFER =new Tablica();
     vect_data = new Vector();
     vect_stamp = new Vector();
     
     serv_conn.open_write(Thost,Tport_write);   

     System.out.println("Transmiting to host :" + Thost + " port :" + Tport_write);

     vol=GIS_db.count();
     if (vol>0)
     {
       bt.disable();
       GIS_db.extract_all(vect_data, vect_stamp, PACKET_LENGHT);
       bt.enable();
 	System.out.println("data received"); 
       BUFFER = (Tablica) vect_data.elementAt(0);
       ob_time = (Long)vect_stamp.elementAt(0);
       time = ob_time.longValue();
       
       serv_conn.write(BUFFER.tab, PACKET_LENGHT);

       p=System.currentTimeMillis()-time;

       for(int ind=1;ind< vect_data.size();ind++)
       {
         BUFFER = (Tablica) vect_data.elementAt(ind);
         ob_time = (Long)vect_stamp.elementAt(ind);
         time = ob_time.longValue();
	
         time+=p;
      
         while (time>System.currentTimeMillis())
            try {sleep(10);} catch (Exception e) {}
         serv_conn.write(BUFFER.tab, PACKET_LENGHT);
       }
     }  
     System.out.println("Writing completed");
     destroy(); 
   }

}    










