import java.sql.*;
import java.util.*;
import Tablica;

/* This class provides access to Oracle RDBMS with use of WebLogic JDBC driver.  */


class GIS_Database
{
  //private ResultSet rs;
  private Connection conn;
  // private PreparedStatement stmt1;

  boolean connected = false;
  int volume;

  public void open()
  {
    Properties props = new Properties();
    props.put("user",     "konrad");
    props.put("password", "konrad");
    props.put("server",   "kayak");


    try {
          if (connected == false)
	  {  
            conn = new weblogic.jdbc.oci.Driver().connect("jdbc:weblogic:oracle", props);
            System.err.println("Connected to Oracle DBMS on NAOS");
            connected = true;
            volume = count();
	  }   
        }
        catch (Exception e) {
          System.err.println("ERROR: Connection to Oracle DBMS on NAOS not completed");
          System.exit(1);
        }
  }

  public void insert(Vector data, Vector stamp)
  {
  //  ts = new java.util.Date();

    Tablica BUFFER;
    Long tstamp;
    int i;
    
    try
      {
	for(i = 0; i < data.size(); i ++) {

	BUFFER = (Tablica) data.elementAt(i);
	tstamp = (Long) stamp.elementAt(i);
	
        PreparedStatement stmt = conn.prepareStatement("insert into GIS_data(ind,dataset,stamp) values (?,?,?)");
        stmt.setInt(1,++volume);  
        stmt.setBytes(2,BUFFER.tab);
	stmt.setLong(3, tstamp.longValue());
    //    stmt.setDate(3,ts);
        stmt.execute();
        stmt.close();
	}
      }
    catch (Exception e) {
        System.err.println("ERROR: cannot insert");
        e.printStackTrace();
        System.exit(1);
      }
  }

public void delete()
  {    
    try
      {
        PreparedStatement st1 = conn.prepareStatement("delete from GIS_data");      
        st1.execute();
	PreparedStatement st2 = conn.prepareStatement("commit");
	st2.execute();
        st1.close();
	st2.close();
      }
    catch (Exception e) {
        System.err.println("ERROR: cannot delete");
        e.printStackTrace();
        System.exit(1);
      }
  }
  
  public void extract_all(Vector vect_data, Vector vect_stamp, int LENGTH)
  {
    Tablica BUFFER = new Tablica();
    BUFFER.tab = new byte[50];
    long stamp;
    Long ob_stamp;

    try
    { 
        PreparedStatement stmt = conn.prepareStatement("select dataset,stamp from GIS_data order by ind");
        ResultSet rs = stmt.executeQuery();
	while (rs.next()==true)
	{
	  BUFFER = new Tablica();
	  BUFFER.tab = new byte[LENGTH];
	  for(int i=0;i<LENGTH;i++) {
           BUFFER.tab[i]=rs.getBytes(1)[i];
		
	  }
		
	  vect_data.addElement(BUFFER);
	  
	  stamp = rs.getLong(2);
	  ob_stamp = new Long(stamp);
	  vect_stamp.addElement(ob_stamp);
	}
	stmt.close();
    }
    catch (Exception e) {
        System.err.println("ERROR: cannot find last");
        e.printStackTrace();
        System.exit(1);
    }
  }
  

  public int count()
  {
    try
      {
        Statement stmt = conn.createStatement();
        ResultSet pom = stmt.executeQuery("select count(*) from GIS_data");
        pom.next();
        int i=pom.getInt("count(*)");
        stmt.close();
        return i;
      }
    catch (Exception e) {
        System.err.println("ERROR: cannot count");
        e.printStackTrace();
        System.exit(1);
        return 0;
      }
  }

  public void close()
  {
    try {
          if (connected == true)
	  {
	    //   conn.close();
            System.err.println("Disconnected from Oracle DBMS on NAOS");
            connected = false;
	  }  
        }
    catch (Exception e) {
          System.err.println("ERROR: Disonnection from Oracle DBMS on NAOS not completed");
	  System.err.println("Err " + e); 
	  //System.exit(1);
        }
  }

  public boolean IsConnected ()
  {
    return connected;
  }
}


































































































































































